package com.gyee.alarm.controller;

import com.alibaba.fastjson.JSONObject;
import com.gyee.alarm.service.DeviceService;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

@Slf4j
@RestController
@RequestMapping("/info")
@CrossOrigin
@Api(value = "获取基础数据，如风场，风机，测点等", tags = "获取基础数据，如风场，风机，测点等")
public class InfoController {
    @Resource
    private DeviceService deviceService;

    @GetMapping(value = "/point")
    @ResponseBody
    public JSONObject getPointList(@RequestParam(value = "deviceId", required = true) String deviceid,
                                   @RequestParam(value = "structcode", required = false) String structCode,
                                   @RequestParam(value = "stationId", required = true) String stationId,
                                   @RequestParam(value = "windturbineId", required = true) String windturbineId,
                                   @RequestParam(value = "pageSize", required = false) Integer pageSize,
                                   @RequestParam(value = "pageNum", required = false) Integer pageNum
    ) {

        if (pageSize == null || pageSize == 0)
            pageSize = 100;
        if (pageNum == null || pageNum == 0)
            pageNum = 1;
        JSONObject testingPoint = deviceService.getTestingPointByStructCode(deviceid, structCode, windturbineId, pageSize, pageNum);
        return testingPoint;
    }
}
