package com.gyee.alarm.model.auto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.gyee.alarm.util.ChineseDes;
import lombok.*;

/**
 * <p>
 * 报警配置表
 * </p>
 *
 * @author shilin
 * @since 2023-06-19
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Builder
@AllArgsConstructor
@NoArgsConstructor
@ToString
public class ProEconAlarmConfiguration extends Model {

    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    private String id;

    /**
     * 测点（如果根据uniformcode配置此字段可为空）
     */
    @ChineseDes("测点")
    @ExcelProperty("测点")
    private String tagId;

    /**
     * 报警类别，0触发，1触发，-1变化触发，4ai点触发
     */
    @ChineseDes("报警触发条件")
    @ExcelProperty("报警触发条件")
    private Integer triggerType;

    /**
     * 设备ID
     */
    @ChineseDes("设备ID")
    @ExcelProperty("设备ID")
    private String deviceId;

    /**
     * 后缀
     */
    @ChineseDes("后缀")
    @ExcelProperty("后缀")
    private String suffix;

    /**
     * 报警级别
     */
    @ChineseDes("报警级别")
    @ExcelProperty("报警级别")
    private Integer rank;

    /**
     * 统一识别码(如果通过uniformCode配置，则设备类型，场站，机型不能为空)
     */
    @ChineseDes("统一识别码")
    @ExcelProperty("统一识别码")
    private String uniformCode;

    /**
     * 场站ID
     */
    @ChineseDes("场站ID")
    @ExcelProperty("场站ID")
    private String stationId;

    /**
     * 机型ID
     */
    @ChineseDes("机型ID")
    @ExcelProperty("机型ID")
    private String modelId;

    /**
     * 报警类型 /自定义报警 custom，风机 windturbine，场站 station，升压站 booststation
     */
    @ChineseDes("报警类型")
    @ExcelProperty("报警类型")
    private String alarmType;

    /**
     * 设备类型，场站 station，风机 windturbine，升压站 booststation
     */
    @ChineseDes("设备类型")
    @ExcelProperty("设备类型")
    private String deviceType;

    /**
     * 设备部件
     */
    @ChineseDes("设备部件")
    @ExcelProperty("设备部件")
    private String components;

    /**
     * 设备子部件
     */
    @ChineseDes("设备子部件")
    @ExcelProperty("设备子部件")
    private String subcomponents;

    /**
     * 报警描述
     */
    @ChineseDes("报警描述")
    @ExcelProperty("报警描述")
    private String description;

    /**
     * 特性
     */
    @ChineseDes("特性")
    @ExcelProperty("特性")
    private String characteristic;

    /**
     * 是否可复位
     */
    @ChineseDes("是否可复位")
    @ExcelProperty("是否可复位")
    private Boolean resetTable;

    /**
     * 是否启用
     */
    @ChineseDes("是否启用")
    @ExcelProperty("是否启用")
    private Boolean enable;


}
