package com.gyee.alarm.service;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gyee.alarm.init.CacheContext;
import com.gyee.alarm.mapper.auto.ProEconAlarmRuleMapper;
import com.gyee.alarm.model.auto.ProBasicPowerstation;
import com.gyee.alarm.model.auto.ProEconAlarmConfiguration;
import com.gyee.alarm.model.auto.ProEconAlarmType;
import com.gyee.alarm.model.vo.AlarmRuleVo;
import com.gyee.alarm.service.auto.IProEconAlarmConfigurationService;
import com.gyee.alarm.util.SnowflakeGenerator;
import com.gyee.alarm.util.StringUtil;
import com.gyee.alarm.util.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Service
public class AlarmConfigurationService {

    @Resource
    private IProEconAlarmConfigurationService roEconAlarmConfigurationService;
    @Resource
    private RuleUpdateEventService ruleUpdateEventService;


    private boolean saveAlertrule(ProEconAlarmConfiguration alarmRule) throws Exception {

        boolean result = false;

        if (StringUtils.notEmp(alarmRule)) {
            
            alarmRule.setId(String.valueOf(SnowflakeGenerator.generateId()));
  
            result= roEconAlarmConfigurationService.save(alarmRule);
        }
//        if (result > 0) {
//            int i = eventService.saveEventWarning(alarmRule, oldRule2, userData.getUserName());
        return result;
    }


    public boolean saveAndUpdateAlertrule(ProEconAlarmConfiguration alarmRule) throws Exception {

        boolean result =false;

        if (StringUtils.notEmp(alarmRule)) {

            if (StringUtils.notEmp(alarmRule.getId())) {

                ProEconAlarmConfiguration  oldRule2 = roEconAlarmConfigurationService.getById(alarmRule.getId());
                if (oldRule2 != null) {

                    result = roEconAlarmConfigurationService.updateById(alarmRule);
                    ruleUpdateEventService.saveEventWarning(alarmRule,oldRule2);
                }else
                {
                    ruleUpdateEventService.saveEventWarning(alarmRule,null);
                    result = saveAlertrule(alarmRule);
                }
            }
            else
            {
                result =  saveAlertrule(alarmRule);
                ruleUpdateEventService.saveEventWarning(alarmRule,null);
            }

        }

        return result;
    }

    public boolean deleteAlertrule(String id) {
        return roEconAlarmConfigurationService.removeById(id);
    }


    public IPage<ProEconAlarmConfiguration> pageQueryAll(Page page, String name, String station, String modelId, String rank, String category, String enabled, String relatedparts) {


        if(StringUtils.notEmp(name))
        {
            name="%"+name+"%";
        }else
        {
            name=null;
        }
        if(StringUtils.empty(station))
        {
            station=null;
        }
        if(StringUtils.empty(modelId))
        {
            modelId=null;
        }


        IPage<ProEconAlarmConfiguration> alertruleIPage = roEconAlarmConfigurationService.pageQueryAll(page, name, station, modelId);

        return alertruleIPage;
    }


}
